// @tensorflow/tfjs-models Copyright 2018 Google
import{util,tidy,keep,div}from"@tensorflow/tfjs";function __awaiter(t,a,e,s){return new(e||(e=Promise))(function(r,n){function i(t){try{o(s.next(t))}catch(t){n(t)}}function l(t){try{o(s.throw(t))}catch(t){n(t)}}function o(t){t.done?r(t.value):new e(function(a){a(t.value)}).then(i,l)}o((s=s.apply(t,a||[])).next())})}function __generator(t,a){var e,s,r,n,i={label:0,sent:function(){if(1&r[0])throw r[1];return r[1]},trys:[],ops:[]};return n={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(n[Symbol.iterator]=function(){return this}),n;function l(n){return function(l){return function(n){if(e)throw new TypeError("Generator is already executing.");for(;i;)try{if(e=1,s&&(r=2&n[0]?s.return:n[0]?s.throw||((r=s.return)&&r.call(s),0):s.next)&&!(r=r.call(s,n[1])).done)return r;switch(s=0,r&&(n=[2&n[0],r.value]),n[0]){case 0:case 1:r=n;break;case 4:return i.label++,{value:n[1],done:!1};case 5:i.label++,s=n[1],n=[0];continue;case 7:n=i.ops.pop(),i.trys.pop();continue;default:if(!(r=(r=i.trys).length>0&&r[r.length-1])&&(6===n[0]||2===n[0])){i=0;continue}if(3===n[0]&&(!r||n[1]>r[0]&&n[1]<r[3])){i.label=n[1];break}if(6===n[0]&&i.label<r[1]){i.label=r[1],r=n;break}if(r&&i.label<r[2]){i.label=r[2],i.ops.push(n);break}r[2]&&i.ops.pop(),i.trys.pop();continue}n=a.call(t,i)}catch(t){n=[6,t],s=0}finally{e=r=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}([n,l])}}}function concatWithNulls(t,a){return null==t&&null==a?null:null==t?a.clone():null===a?t.clone():t.concat(a,0)}function topK(t,a){for(var e=[],s=0;s<t.length;s++)e.push({value:t[s],index:s});e.sort(function(t,a){return a.value-t.value});var r=new Float32Array(a),n=new Int32Array(a);for(s=0;s<a;s++)r[s]=e[s].value,n[s]=e[s].index;return{values:r,indices:n}}var KNNClassifier=function(){function t(){this.classDatasetMatrices={},this.classExampleCount={}}return t.prototype.addExample=function(t,a){var e=this;if(null==this.exampleShape&&(this.exampleShape=t.shape),!util.arraysEqual(this.exampleShape,t.shape))throw new Error("Example shape provided, "+t.shape+" does not match previously provided example shapes "+this.exampleShape+".");if(!Number.isInteger(a))throw new Error("classIndex must be an integer, got "+a+".");this.clearTrainDatasetMatrix(),tidy(function(){var s=e.normalizeVectorToUnitLength(t.flatten()),r=s.shape[0];if(null==e.classDatasetMatrices[a])e.classDatasetMatrices[a]=s.as2D(1,r);else{var n=e.classDatasetMatrices[a].as2D(e.classExampleCount[a],r).concat(s.as2D(1,r),0);e.classDatasetMatrices[a].dispose(),e.classDatasetMatrices[a]=n}keep(e.classDatasetMatrices[a]),null==e.classExampleCount[a]&&(e.classExampleCount[a]=0),e.classExampleCount[a]++})},t.prototype.similarities=function(t){var a=this;return tidy(function(){var e=a.normalizeVectorToUnitLength(t.flatten()),s=e.shape[0];if(null==a.trainDatasetMatrix){var r=null;for(var n in a.classDatasetMatrices)r=concatWithNulls(r,a.classDatasetMatrices[n]);a.trainDatasetMatrix=r}if(null==a.trainDatasetMatrix)return console.warn("Cannot predict without providing training examples."),null;keep(a.trainDatasetMatrix);var i=a.getNumExamples();return a.trainDatasetMatrix.as2D(i,s).matMul(e.as2D(s,1)).as1D()})},t.prototype.predictClass=function(t,a){return void 0===a&&(a=3),__awaiter(this,void 0,void 0,function(){var e,s,r,n,i=this;return __generator(this,function(l){switch(l.label){case 0:if(a<1)throw new Error("Please provide a positive integer k value to predictClass.");if(0===this.getNumExamples())throw new Error("You have not added any exaples to the KNN classifier. Please add examples before calling predictClass.");return e=tidy(function(){return i.similarities(t).asType("float32")}),s=Math.min(a,this.getNumExamples()),n=topK,[4,e.data()];case 1:return r=n.apply(void 0,[l.sent(),s]).indices,e.dispose(),[2,this.calculateTopClass(r,s)]}})})},t.prototype.clearClass=function(t){if(null==this.classDatasetMatrices[t])throw new Error("Cannot clear invalid class ${classIndex}");delete this.classDatasetMatrices[t],delete this.classExampleCount[t],this.clearTrainDatasetMatrix()},t.prototype.clearAllClasses=function(){for(var t in this.classDatasetMatrices)this.clearClass(+t)},t.prototype.getClassExampleCount=function(){return this.classExampleCount},t.prototype.getClassifierDataset=function(){return this.classDatasetMatrices},t.prototype.getNumClasses=function(){return Object.keys(this.classExampleCount).length},t.prototype.setClassifierDataset=function(t){for(var a in this.clearTrainDatasetMatrix(),this.classDatasetMatrices=t,t)this.classExampleCount[a]=t[a].shape[0]},t.prototype.calculateTopClass=function(t,a){var e=-1,s={};if(null==t)return{classIndex:e,confidences:s};var r=[];for(var n in this.classDatasetMatrices){var i=this.classExampleCount[n];+n>0&&(i+=r[+n-1]),r.push(i)}var l=Array(Object.keys(this.classDatasetMatrices).length).fill(0);for(n=0;n<t.length;n++)for(var o=0;o<r.length;o++)if(t[n]<r[o]){l[o]++;break}var c=0;for(var n in this.classDatasetMatrices){var u=l[n]/a;u>c&&(c=u,e=+n),s[n]=u}return{classIndex:e,confidences:s}},t.prototype.clearTrainDatasetMatrix=function(){null!=this.trainDatasetMatrix&&(this.trainDatasetMatrix.dispose(),this.trainDatasetMatrix=null)},t.prototype.normalizeVectorToUnitLength=function(t){return tidy(function(){var a=t.norm();return div(t,a)})},t.prototype.getNumExamples=function(){var t=0;for(var a in this.classDatasetMatrices)t+=this.classExampleCount[+a];return t},t.prototype.dispose=function(){for(var t in this.clearTrainDatasetMatrix(),this.classDatasetMatrices)this.classDatasetMatrices[t].dispose()},t}();function create(){return new KNNClassifier}export{KNNClassifier,create};
